<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Chapitre 4. Fichiers nécessaires dans le répertoire debian</title>
    <link rel="stylesheet" type="text/css" href="debian.css"/>
    <meta name="generator" content="DocBook XSL Stylesheets V1.78.1"/>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="home" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="up" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="prev" href="modify.fr.html" title="Chapitre 3. Modification du code source"/>
    <link rel="next" href="dother.fr.html" title="Chapitre 5. Autres fichiers dans le répertoire debian"/>
  </head>
  <body>
    <div class="navheader">
      <table width="100%" summary="Navigation header">
        <tr>
          <th colspan="3" align="center">Chapitre 4. Fichiers nécessaires dans le répertoire <code class="filename">debian</code></th>
        </tr>
        <tr>
          <td align="left"><a accesskey="p" href="modify.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <th width="60%" align="center"> </th>
          <td align="right"> <a accesskey="n" href="dother.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
      </table>
      <hr/>
    </div>
    <div class="chapter">
      <div class="titlepage">
        <div>
          <div>
            <h1 class="title"><a id="dreq"/>Chapitre 4. Fichiers nécessaires dans le répertoire <code class="filename">debian</code></h1>
          </div>
        </div>
      </div>
      <div class="toc">
        <p>
          <strong>Table des matières</strong>
        </p>
        <dl class="toc">
          <dt>
            <span class="section">
              <a href="dreq.fr.html#control">4.1. <code class="filename">control</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dreq.fr.html#copyright">4.2. <code class="filename">copyright</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dreq.fr.html#changelog">4.3. <code class="filename">changelog</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dreq.fr.html#rules">4.4. <code class="filename">rules</code></a>
            </span>
          </dt>
          <dd>
            <dl>
              <dt>
                <span class="section">
                  <a href="dreq.fr.html#targets">4.4.1. Cibles du fichier <code class="filename">rules</code></a>
                </span>
              </dt>
              <dt>
                <span class="section">
                  <a href="dreq.fr.html#defaultrules">4.4.2. Fichier <code class="filename">rules</code> par défaut</a>
                </span>
              </dt>
              <dt>
                <span class="section">
                  <a href="dreq.fr.html#customrules">4.4.3. Personnalisation du fichier <code class="filename">rules</code></a>
                </span>
              </dt>
            </dl>
          </dd>
        </dl>
      </div>
      <p>
Un nouveau sous-répertoire se trouve dans le répertoire des sources du
programme, nommé <code class="filename">debian</code>. Certains fichiers de ce
répertoire sont à modifier pour personnaliser le comportement du paquet. Les
plus importants sont <code class="filename">control</code>,
<code class="filename">changelog</code>, <code class="filename">copyright</code> et
<code class="filename">rules</code>, ils sont nécessaires pour tous les
paquets. <a href="#ftn.idp38807984" class="footnote" id="idp38807984"><sup class="footnote">[27]</sup></a>
</p>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="control"/>4.1. <code class="filename">control</code></h2>
            </div>
          </div>
        </div>
        <p>
Ce fichier contient plusieurs valeurs utilisées par <span class="command"><strong>dpkg</strong></span>,
<span class="command"><strong>dselect</strong></span>, <span class="command"><strong>apt-get</strong></span>,
<span class="command"><strong>apt-cache</strong></span>, <span class="command"><strong>aptitude</strong></span> et d'autres outils
de gestion de paquets pour gérer le paquet. Cela est défini par la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-controlfields.html">Charte Debian, 5 « Fichiers de contrôle et leurs
champs »</a>.
</p>
        <p>
Le fichier <code class="filename">control</code> créé par <span class="command"><strong>dh_make</strong></span>
ressemble à :
</p>
        <pre class="screen">
 1 Source: gentoo
 2 Section: unknown
 3 Priority: extra
 4 Maintainer: Prénom Nom &lt;votre.adresse.mail@example.org&gt;
 5 Build-Depends: debhelper (&gt;=9)
 6 Standards-Version: 3.9.4
 7 Homepage: &lt;URL amont, si pertinente&gt;
 8
 9 Package: gentoo
10 Architecture: any
11 Depends: ${shlibs:Depends}, ${misc:Depends}
12 Description: &lt;description courte de 60 caractères au maximum&gt;
13  &lt;description longue, indentée par des espaces&gt;
</pre>
        <p>
(Les numéros de ligne ont été ajoutés.)
</p>
        <p>
Les lignes 1 à 7 sont les informations de contrôle pour le paquet
source. Les lignes 9 à 13 sont les informations de contrôle pour le paquet
binaire.
</p>
        <p>
La ligne 1 est le nom du paquet source.
</p>
        <p>
La ligne 2 est la section de la distribution à laquelle ce paquet
appartient.
</p>
        <p>
Comme vous avez pu le constater, l'archive Debian est divisée en plusieurs
parties : <code class="literal">main</code> (logiciels libres),
<code class="literal">non-free</code> (logiciels non libres), et
<code class="literal">contrib</code> (logiciels libres qui dépendent de logiciels non
libres). Chacune d'entre elles est divisée en sections qui classent les
paquets en catégories grossières. Entre autres existent
<code class="literal">admin</code> pour les programmes destinés aux administrateurs,
<code class="literal">devel</code> pour les outils de programmation,
<code class="literal">doc</code> pour la documentation, <code class="literal">libs</code> pour
les bibliothèques, <code class="literal">mail</code> pour les lecteurs et les démons
de courrier électronique, <code class="literal">net</code> pour les applications et
démons de réseau, <code class="literal">x11</code> pour les programmes X11 qui ne
conviennent pas mieux ailleurs, et bien d'autres. <a href="#ftn.idp38824480" class="footnote" id="idp38824480"><sup class="footnote">[28]</sup></a>
</p>
        <p>
Changez la section en x11 (le préfixe <code class="literal">main/</code> est
implicite, et peut donc être omis).
</p>
        <p>
La ligne 3 décrit l'importance pour l'utilisateur d'installer ce paquet :
<a href="#ftn.idp38828640" class="footnote" id="idp38828640"><sup class="footnote">[29]</sup></a>
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
la priorité <code class="literal">optional</code> fonctionne habituellement pour les
nouveaux paquets qui ne sont pas en conflit avec d'autres se réclamant de
priorité <code class="literal">required</code>, <code class="literal">important</code> ou
<code class="literal">standard</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
la priorité <code class="literal">extra</code> fonctionne habituellement pour les
nouveaux paquets qui sont en conflit avec d'autres de priorité non
<code class="literal">extra</code>.
</p>
            </li>
          </ul>
        </div>
        <p>
Les sections et les priorités sont utilisées par des interfaces comme
<span class="command"><strong>aptitude</strong></span> quand elles trient les paquets et sélectionnent
les valeurs par défaut. Quand vous enverrez le paquet dans Debian, les
valeurs de ces deux champs peuvent être modifiées par les responsables des
archives, auquel cas vous serez notifié par courrier.
</p>
        <p>
Comme c'est un paquet de priorité normale et qu'il n'entre pas en conflit
avec quoi que ce soit, il suffit de laisser la priorité à
<code class="literal">optional</code>.
</p>
        <p>
La ligne 4 est le nom et l'adresse électronique du responsable. Assurez-vous
que ce champ contient un en-tête <code class="literal">To</code> valable pour un
courrier électronique, car après l'envoi du paquet, le système de suivi des
bogues l'utilisera pour vous distribuer les courriers relatifs aux
bogues. Évitez d'utiliser les virgules, esperluettes
(<code class="literal">&amp;</code>) ou parenthèses.
</p>
        <p>
La ligne 5 contient la liste des paquets nécessaires pour construire le
paquet dans le champ <code class="literal">Build-Depends</code>. Le champ
<code class="literal">Build-Depends-Indep</code> peut-être ajouté dans une ligne
supplémentaire. <a href="#ftn.idp38841424" class="footnote" id="idp38841424"><sup class="footnote">[30]</sup></a> Certains paquets comme
<code class="systemitem">gcc</code> ou <code class="systemitem">make</code> sont implicites, puisqu'ils dépendent de
<code class="systemitem">build-essential</code>. Si d'autres outils
sont nécessaires pour construire le paquet, vous devez les ajouter à ces
champs. Les multiples éléments sont séparées par des virgules ; lisez
ci-après les explications sur les dépendances entre paquets binaires pour
mieux comprendre la syntaxe de ces lignes :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
pour tous les paquets empaquetés avec la commande <span class="command"><strong>dh</strong></span> dans
le fichier <code class="filename">debian/rules</code>, <code class="literal">debhelper
(&gt;=9)</code> doit faire partie du champ
<code class="literal">Build-Depends</code> pour être conforme à la Charte Debian au
sujet de la cible <code class="literal">clean</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
les paquets source de paquets binaires avec <code class="literal">Architecture:
any</code> sont reconstruits par les empaqueteurs automatiques
(« autobuilder »). Puisque la procédure des serveurs d'empaquetage
automatique installe seulement les paquets indiqués dans le champ
<code class="literal">Build-Depends</code> avant d'exécuter <code class="literal">debian/rules
build</code> (consultez <a class="xref" href="build.fr.html#autobuilder" title="6.2. Serveurs d'empaquetage automatique (« autobuilder »)">Section 6.2, « Serveurs d'empaquetage automatique (« autobuilder ») »</a>), ce champ
<code class="literal">Build-Depends</code> doit indiquer pratiquement tous les paquets
nécessaires et <code class="literal">Build-Depends-Indep</code> est rarement utilisé ;
</p>
            </li>
            <li class="listitem">
              <p>
pour les paquets source de paquets binaires dont tous sont
<code class="literal">Architecture: all</code>, le champ
<code class="literal">Build-Depends-Indep</code> peut indiquer tous les paquets
nécessaires à moins qu'ils ne soient déjà indiqués dans le champ
<code class="literal">Build-Depends</code> pour être conforme à la Charte Debian au
sujet de la cible <code class="literal">clean</code>.
</p>
            </li>
          </ul>
        </div>
        <p>
En cas de doute, utilisez le champ <code class="literal">Build-Depends</code> pour
être sûr.  <a href="#ftn.idp38857152" class="footnote" id="idp38857152"><sup class="footnote">[31]</sup></a>
</p>
        <p>
Pour déterminer les paquets nécessaires à la construction, exécutez la
commande :
</p>
        <pre class="screen">
$ dpkg-depcheck -d ./configure
</pre>
        <p>
Pour déterminer manuellement les dépendances de construction exactes pour
<span class="command"><strong><em class="replaceable"><code>/usr/bin/toto</code></em></strong></span>, exécutez :
</p>
        <pre class="screen">
$ objdump -p <em class="replaceable"><code>/usr/bin/toto</code></em> | grep NEEDED
</pre>
        <p>
et pour chaque bibliothèque affichée, par exemple
<span class="command"><strong>libtoto.so.6</strong></span>, exécutez
</p>
        <pre class="screen">
$ dpkg -S libtoto.so.6
</pre>
        <p>
Ajoutez ensuite simplement la version <code class="literal">-dev</code> de chaque
paquet dans le champ <code class="literal">Build-Depends</code>. Si vous utilisez
<span class="command"><strong>ldd</strong></span> à cet effet, des dépendances de bibliothèque
indirectes seront indiquées, introduisant un problème de dépendances de
construction excessives.
</p>
        <p>
<code class="systemitem">gentoo</code> a aussi besoin de <code class="systemitem">xlibs-dev</code>, <code class="systemitem">libgtk1.2-dev</code> et <code class="systemitem">libgl1.2-dev</code> pour être construit, ils doivent
donc être ajoutés à côté de <code class="systemitem">debhelper</code>.
</p>
        <p>
La ligne 6 est la version de la <a class="ulink" href="http://www.debian.org/doc/devel-manuals#policy">Charte
Debian</a> que ce paquet respecte, celle que vous lisez quand vous créez
le paquet.
</p>
        <p>
En ligne 7 vous pouvez indiquer l'URL de la page d'accueil du programme
amont.
</p>
        <p>
La ligne 9 est le nom du paquet binaire. C'est d'ordinaire le même que le
nom du paquet source, mais ce n'est pas nécessairement le cas.
</p>
        <p>
La ligne 10 décrit les architectures pour lesquelles le paquet binaire peut
être compilé. Cette valeur est en général un des suivantes en fonction du
type de paquet binaire : <a href="#ftn.idp38875136" class="footnote" id="idp38875136"><sup class="footnote">[32]</sup></a>
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
                <code class="literal">Architecture: any</code>
              </p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>le paquet binaire créé dépend de l'architecture, en général dans un langage
compilé ;</p>
                  </li>
                </ul>
              </div>
            </li>
            <li class="listitem">
              <p>
                <code class="literal">Architecture: all</code>
              </p>
              <div class="itemizedlist">
                <ul class="itemizedlist">
                  <li class="listitem">
                    <p>le paquet binaire créé est indépendant de l'architecture, en général du
texte, des images ou des scripts en langage interprété.</p>
                  </li>
                </ul>
              </div>
            </li>
          </ul>
        </div>
        <p>
La ligne 10 est laissée telle quelle car c'est écrit en
C.
<span class="citerefentry"><span class="refentrytitle">dpkg-gencontrol</span>(1)</span>
indiquera la valeur d'architecture appropriée pour chaque machine sur
laquelle ce paquet source sera compilé.
</p>
        <p>
Si le paquet est indépendant d'une architecture (par exemple, un script
shell ou Perl, ou un document), changez ce paramètre en
<code class="literal">all</code>, et lisez plus loin en <a class="xref" href="dreq.fr.html#rules" title="4.4. rules">Section 4.4, « <code class="filename">rules</code> »</a>
comment utiliser la règle <code class="literal">binary-indep</code> au lieu de
<code class="literal">binary-arch</code> pour construire le paquet.
</p>
        <p>
La ligne 11 montre une des caractéristiques les plus puissantes du système
de paquet Debian. Les paquets peuvent être liés entre eux de plusieurs
façons. Hormis <code class="literal">Depends</code>, les autres champs décrivant ces
relations sont <code class="literal">Recommends</code>, <code class="literal">Suggests</code>,
<code class="literal">Pre-Depends</code>, <code class="literal">Breaks</code>,
<code class="literal">Conflicts</code>, <code class="literal">Provides</code> et
<code class="literal">Replaces</code>.
</p>
        <p>
Les outils de gestion de paquets se comportent d'ordinaire de la même
manière quand ils gèrent ces relations ; sinon, ce sera précisé (consultez
<span class="citerefentry"><span class="refentrytitle">dpkg</span>(8)</span>, <span class="citerefentry"><span class="refentrytitle">dselect</span>(8)</span>, <span class="citerefentry"><span class="refentrytitle">apt</span>(8)</span>,
<span class="citerefentry"><span class="refentrytitle">aptitude</span>(1)</span>, etc.)
</p>
        <p>
Voici une description simplifiée des relations entre paquets : <a href="#ftn.idp38895088" class="footnote" id="idp38895088"><sup class="footnote">[33]</sup></a>
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<code class="literal">Depends</code>
</p>
              <p>
le paquet ne sera pas installé sans que les paquets dont il dépend ne soient
installés. Utilisez-le si le programme ne s'exécute absolument pas (ou cause
des dégâts sérieux) si un paquet particulier n'est pas présent ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">Recommends</code>
</p>
              <p>
à utiliser pour les paquets qui ne sont pas vraiment indispensables mais qui
sont généralement utilisés avec le programme. Lorsqu'un utilisateur installe
le paquet, toutes les interfaces devraient proposer d'installer les paquets
recommandés. <span class="command"><strong>aptitude</strong></span> et <span class="command"><strong>apt-get</strong></span>
installent par défaut les paquets recommandés avec le paquet (mais
l'utilisateur peut désactiver ce comportement). <span class="command"><strong>dpkg</strong></span>
ignorera ce champ ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">Suggests</code>
</p>
              <p>
à utiliser pour les paquets qui fonctionnent bien avec le programme mais qui
ne sont pas du tout indispensables. Lorsqu'un utilisateur installe le
programme, il ne lui sera probablement pas proposé d'installer les paquets
suggérés. <span class="command"><strong>aptitude</strong></span> peut être configuré pour installer les
paquets suggérés avec le paquet mais ce n'est pas le comportement par
défaut. <span class="command"><strong>dpkg</strong></span> et <span class="command"><strong>apt-get</strong></span> ignoreront ce
champ ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">Pre-Depends</code>
</p>
              <p>
cela est plus fort que <code class="literal">Depends</code>. Le paquet ne sera pas
installé avant que les paquets dont il pré-dépend ne soient installés et
<span class="emphasis"><em>correctement configurés</em></span>. Utilisez-le
<span class="emphasis"><em>très</em></span> rarement et seulement après en avoir discuté sur
la liste de discussion <a class="ulink" href="http://lists.debian.org/debian-devel/">debian-devel@lists.debian.org</a>. Autrement
dit : ne l'utilisez pas du tout ; :-)
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">Conflicts</code>
</p>
              <p>
le paquet ne sera pas installé tant que les paquets avec lesquels il est en
conflit n'aient été retirés. À utiliser si le programme ne peut absolument
pas fonctionner ou s'il cause d'énormes problèmes quand un paquet
particulier est présent ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">Breaks</code>
</p>
              <p>
les paquets énumérés seront cassés une fois que le paquet ait été
installé. En général, une entrée <code class="literal">Breaks</code> indique qu'elle
s'applique aux versions antérieures à une certaine valeur. La résolution de
conflit se fait en utilisant des gestionnaires de paquets de haut niveau
pour généralement à mettre à niveau les paquets énumérés ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">Provides</code>
</p>
              <p>
quand il y a plusieurs alternatives pour certains types de paquets, des noms
virtuels ont été définis. La liste complète est disponible dans le fichier
<a class="ulink" href="http://www.debian.org/doc/packaging-manuals/virtual-package-names-list.txt">virtual-package-names-list.txt.gz</a>. À
utiliser si le programme fournit une fonction d'un paquet virtuel existant ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">Replaces</code>
</p>
              <p>
à utiliser quand le programme remplace des fichiers d'un autre paquet, ou
remplace complètement un autre paquet (utilisé en conjonction avec
<code class="literal">Conflicts</code>).  Les fichiers du paquet nommé seront écrasés
par les fichiers de votre paquet.
</p>
            </li>
          </ul>
        </div>
        <p>
Tous ces champs ont une syntaxe uniforme. Il s'agit d'une liste de paquets
séparés par des virgules. Ces noms de paquets peuvent aussi être une liste
d'alternatives, séparées par des barres verticales <code class="literal">|</code>
(symbole tube ou « pipe »).
</p>
        <p>
Le domaine d'application des champs peut être restreint à des versions
particulières de chaque paquet nommé. La restriction de chaque paquet
particulier est indiquée entre parenthèses après son nom, et devrait
contenir une relation dans la liste suivante suivie par une valeur de numéro
de version. Les relations autorisées sont <code class="literal">&lt;&lt;</code>,
<code class="literal">&lt;=</code>, <code class="literal">=</code>, <code class="literal">&gt;=</code> et
<code class="literal">&gt;&gt;</code> (respectivement : strictement plus petit, plus
petit ou égal, exactement égal, plus grand ou égal et strictement plus
grand). Par exemple :
</p>
        <pre class="screen">
Depends: toto (&gt;= 1.2), libbidule1 (= 1.3.4)
Conflicts: machin
Recommends: libmachin4 (&gt;&gt; 4.0.7)
Suggests: truc
Replaces: truc (&lt;&lt; 5), truc-toto (&lt;= 7.6)
</pre>
        <p>
La dernière fonctionnalité à connaître est
<code class="literal">${shlibs:Depends}</code>, <code class="literal">${perl:Depends}</code>,
<code class="literal">${misc:Depends}</code>, etc.
</p>
        <p>
<span class="citerefentry"><span class="refentrytitle">dh_shlibdeps</span>(1)</span> calcule les dépendances en
bibliothèques partagées pour les paquets binaires. Il crée une liste
d'exécutables <a class="ulink" href="http://fr.wikipedia.org/wiki/Executable_and_Linkable_Format">ELF</a> et de bibliothèques partagées
trouvées pour chaque paquet binaire. Cette liste est utilisée en
remplacement de <code class="literal">${shlibs:Depends}</code>.
</p>
        <p>
<span class="citerefentry"><span class="refentrytitle">dh_perl</span>(1)</span> calcule les dépendances de Perl. Il
crée une liste de dépendances vers <code class="literal">perl</code> ou
<code class="literal">perlapi</code> pour chaque paquet binaire. Cette liste est
utilisée en remplacement de <code class="literal">${perl:Depends}</code>.
</p>
        <p>
Certaines commandes de <code class="systemitem">debhelper</code>
peuvent rendre le paquet créé dépendant de paquets supplémentaires. Toutes
ces commandes créent une liste de paquets nécessaires pour chaque paquet
binaire. Cette liste est utilisée en remplacement de
<code class="literal">${misc:Depends}</code>.
</p>
        <p>
<span class="citerefentry"><span class="refentrytitle">dh_gencontrol</span>(1)</span> crée
<code class="filename">DEBIAN/control</code> pour chaque paquet binaire en
substituant <code class="literal">${shlibs:Depends}</code>,
<code class="literal">${perl:Depends}</code>, <code class="literal">${misc:Depends}</code>, etc.
</p>
        <p>
Cela dit, le champ <code class="literal">Depends</code> peut rester exactement comme
il est maintenant, et une autre ligne avec <code class="literal">Suggests: file</code>
peut être ajoutée, car <code class="systemitem">gentoo</code> peut
utiliser certaines fonctionnalités fournies par le paquet <code class="systemitem">file</code>.
</p>
        <p> La ligne 9 est l'URL de la page d'accueil. Supposons qu'il s'agisse de
<a class="ulink" href="http://www.obsession.se/gentoo/">http://www.obsession.se/gentoo/</a>.
</p>
        <p>
La ligne 12 est la description courte. Les terminaux sont larges de
80 colonnes par convention, aussi elle ne devrait pas dépasser les
60 caractères. <code class="literal">fully GUI-configurable, two-pane X file
manager</code> convient ici.
</p>
        <p>
À la ligne 13 commence la description longue. Celle-ci devrait être un
paragraphe qui donne plus de détails sur le paquet. La colonne 1 de chaque
ligne doit être vide. Il ne peut y avoir de ligne vide, mais vous pouvez
mettre un seul <code class="literal">.</code> (point) dans la colonne 2 pour simuler
une ligne vide. De plus, il ne peut pas y avoir plus d'une ligne vide après
la description longue. <a href="#ftn.idp38946320" class="footnote" id="idp38946320"><sup class="footnote">[34]</sup></a>
</p>
        <p>
Le champ <code class="literal">Vcs-*</code> pour documenter le système de gestion de
versions (VCS) peut être inséré entre les lignes 6 et 7. <a href="#ftn.idp38948800" class="footnote" id="idp38948800"><sup class="footnote">[35]</sup></a> Considérons que le paquet <code class="systemitem">gentoo</code> a son VCS localisé sur le service Git
d'Alioth en
<code class="literal">git://git.debian.org/git/collab-maint/gentoo.git</code>.
</p>
        <p>
Finalement, voici le fichier <code class="filename">control</code> mis à jour :
</p>
        <pre class="screen">
 1 Source: gentoo
 2 Section: x11
 3 Priority: optional
 4 Maintainer: Prénom Nom &lt;votre.adresse.mail@example.org&gt;
 5 Build-Depends: debhelper (&gt;=9), xlibs-dev, libgtk1.2-dev, libglib1.2-dev
 6 Standards-Version: 3.9.4
 7 Vcs-Git: git://git.debian.org/git/collab-maint/gentoo.git
 8 Vcs-browser: http://git.debian.org/?p=collab-maint/gentoo.git
 9 Homepage: http://www.obsession.se/gentoo/
10
11 Package: gentoo
12 Architecture: any
13 Depends: ${shlibs:Depends}, ${misc:Depends}
14 Suggests: file
15 Description: fully GUI-configurable, two-pane X file manager
16  gentoo is a two-pane file manager for the X Window System. gentoo lets the
17  user do (almost) all of the configuration and customizing from within the
18  program itself. If you still prefer to hand-edit configuration files,
19  they're fairly easy to work with since they are written in an XML format.
20  .
21  gentoo features a fairly complex and powerful file identification system,
22  coupled to an object-oriented style system, which together give you a lot
23  of control over how files of different types are displayed and acted upon.
24  Additionally, over a hundred pixmap images are available for use in file
25  type descriptions.
26  .
29  gentoo was written from scratch in ANSI C, and it utilizes the GTK+ toolkit
30  for its interface.
</pre>
        <p>
(Les numéros de ligne ont été ajoutés.)
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="copyright"/>4.2. <code class="filename">copyright</code></h2>
            </div>
          </div>
        </div>
        <p>
Ce fichier contient des renseignements sur le copyright et la licence des
sources amont. La <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-docs.html#s-copyrightfile">Charte Debian,
12.5 « Informations sur le copyright »</a> impose son contenu et la
<a class="ulink" href="http://dep.debian.net/deps/dep5/">DEP-5 : <code class="filename">debian/copyright</code> analysable
automatiquement</a> fournit des directives pour son format.
</p>
        <p>
<span class="command"><strong>dh_make</strong></span> peut proposer un modèle de fichier
<code class="filename">copyright</code>. L'option <code class="literal">--copyright gpl2</code>
peut être utilisée ici pour obtenir un modèle de fichier pour le paquet
<code class="systemitem">gentoo</code> publié sous GPL-2.
</p>
        <p>
Les choses à ajouter obligatoirement à ce fichier sont l'endroit où vous
avez trouvé ce paquet, ainsi que le copyright et la licence d'exploitation
réelle. Si la licence est une des licences de logiciel libre populaires (GNU
GPL-1, GNU GPL-2, GNU GPL-3, LGPL-2, LGPL-2.1, LGPL-3, GNU FDL-1.2, GNU
FDL-1.3, Apache ou Artistic), vous pouvez juste faire référence au fichier
approprié dans le répertoire
<code class="filename">/usr/share/common-licenses/</code>, qui existe sur chaque
système Debian. Sinon, vous devez inclure la licence en entier.
</p>
        <p>
En bref, voici ce à quoi le fichier <code class="filename">copyright</code> de
<code class="systemitem">gentoo</code> devrait ressembler :
</p>
        <pre class="screen">
 1 Format-Specification: http://svn.debian.org/wsvn/dep/web/deps/dep5.mdwn?op=file&amp;rev=135
 2 Name: gentoo
 3 Maintainer: Prénom Nom &lt;votre.adresse.mail@example.org&gt;
 4 Source: http://sourceforge.net/projects/gentoo/files/
 5
 6 Copyright: 1998-2010 Emil Brink &lt;emil@obsession.se&gt;
 7 License: GPL-2+
 8
 9 Files: icons/*
10 Copyright: 1998 Johan Hanson &lt;johan@tiq.com&gt;
11 License: GPL-2+
12
13 Files: debian/*
14 Copyright: 2010 Prénom Nom &lt;votre.adresse.mail@example.org&gt;
15 License: GPL-2+
16
17 License: GPL-2+
18  This program is free software; you can redistribute it and/or modify
19  it under the terms of the GNU General Public License as published by
20  the Free Software Foundation; either version 2 of the License, or
21  (at your option) any later version. 
22  .
23  This program is distributed in the hope that it will be useful,
24  but WITHOUT ANY WARRANTY; without even the implied warranty of
25  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
26  GNU General Public License for more details.
27  .
28  You should have received a copy of the GNU General Public License along
29  with this program; if not, write to the Free Software Foundation, Inc.,
30  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
31  .
32  On Debian systems, the full text of the GNU General Public
33  License version 2 can be found in the file
34  `/usr/share/common-licenses/GPL-2'.
</pre>
        <p>
(Les numéros de ligne ont été ajoutés.)
</p>
        <p>
Veuillez suivre les indications fournies par les responsables de l'archive
et envoyées sur la liste debian-devel-announce : <a class="ulink" href="http://lists.debian.org/debian-devel-announce/2006/03/msg00023.html">http://lists.debian.org/debian-devel-announce/2006/03/msg00023.html</a>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="changelog"/>4.3. <code class="filename">changelog</code></h2>
            </div>
          </div>
        </div>
        <p>
C'est un fichier obligatoire, avec un format spécifique décrit dans la
<a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-source.html#s-dpkgchangelog">Charte Debian,
4.4 « debian/changelog »</a>. Ce format est utilisé par
<span class="command"><strong>dpkg</strong></span> et d'autres programmes pour obtenir le numéro de
version, de révision, de distribution et l'urgence de votre paquet.
</p>
        <p>
Pour vous, il est également important, puisqu'il est bon de documenter
toutes les modifications effectuées. Cela permettra aux personnes qui
téléchargent le paquet de voir s'il y a des problèmes à connaître. Il sera
conservé en <code class="filename">/usr/share/doc/gentoo/changelog.Debian.gz</code>
dans le paquet binaire.
</p>
        <p>
<span class="command"><strong>dh_make</strong></span> en crée un par défaut, et il ressemble à ceci :
</p>
        <pre class="screen">
1  gentoo (0.9.12-1) unstable; urgency=low
2
3   * Initial release (Closes: #<em class="replaceable"><code>nnnn</code></em>)  &lt;<em class="replaceable"><code>nnnn</code></em> est le numéro de bogue de votre ITP&gt;
4
5  -- Prénom Nom &lt;votre.adresse.mail@example.org&gt;  Mon, 22 Mar 2010 00:37:31 +0100
6
</pre>
        <p>
(Les numéros de ligne ont été ajoutés.)
</p>
        <p>
La ligne 1 contient le nom du paquet, la version, la distribution et
l'urgence. Le nom doit correspondre au nom du paquet source, la distribution
devrait être <code class="literal">unstable</code>, et l'urgence ne devrait pas être
changée en quoi que ce soit de supérieur à <code class="literal">low</code>. :-)
</p>
        <p>
Les lignes 3 à 5 composent l'entrée de journal, où vous documentez les
modifications effectuées dans la révision du paquet (pas les modifications
amont — il y a un fichier spécial pour cela, créé par les auteurs amont, que
vous installerez comme
<code class="filename">/usr/share/doc/gentoo/changelog.gz</code>). Supposons que
votre rapport de bogue ITP (« Intent To Package » ou intention d'empaqueter)
avait pour numéro <code class="literal">12345</code>. Les nouvelles lignes doivent
être insérées juste en dessous de la première ligne qui commence avec une
astérisque (<code class="literal">*</code>). Vous pouvez utiliser <span class="citerefentry"><span class="refentrytitle">dch</span>(1)</span>
pour le modifier.
</p>
        <p>
Pour éviter d'envoyer un paquet accidentellement avant qu'il ne soit
terminé, il vaut mieux modifier la valeur de distribution à
<code class="literal">UNRELEASED</code> qui n'est pas valable.
</p>
        <p>
Vous obtiendrez quelque chose comme :
</p>
        <pre class="screen">
1  gentoo (0.9.12-1) UNRELEASED; urgency=low
2
3   * Initial Release. Closes: #12345
4   * This is my first Debian package.
5   * Adjusted the Makefile to fix $(DESTDIR) problems.
6
7  -- Prénom Nom &lt;votre.adresse.mail@example.org&gt;  Mon, 22 Mar 2010 00:37:31 +0100
8
</pre>
        <p>
(Les numéros de ligne ont été ajoutés.)
</p>
        <p>
Une fois satisfait de toutes les modifications, correctement documentées
dans <code class="filename">changelog</code>, vous devriez modifier la valeur de
distribution d'<code class="literal">UNRELEASED</code> à la valeur de distribution
cible <code class="literal">unstable</code> (ou même
<code class="literal">experimental</code>). <a href="#ftn.idp38988224" class="footnote" id="idp38988224"><sup class="footnote">[36]</sup></a>
</p>
        <p>
Vous pouvez en apprendre plus sur la mise à jour du fichier
<code class="filename">changelog</code> plus loin en <a class="xref" href="update.fr.html" title="Chapitre 8. Mise à jour de paquet">Chapitre 8, <em>Mise à jour de paquet</em></a>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="rules"/>4.4. <code class="filename">rules</code></h2>
            </div>
          </div>
        </div>
        <p>
Il faut maintenant examiner les règles utilisées par <span class="citerefentry"><span class="refentrytitle">dpkg-buildpackage</span>(1)</span> pour créer vraiment le paquet. Ce fichier est en fait un
autre <code class="filename">Makefile</code>, mais différent de ceux des sources
amont. Contrairement aux autres fichiers de <code class="filename">debian</code>,
celui-ci est marqué comme exécutable.
</p>
        <div class="section">
          <div class="titlepage">
            <div>
              <div>
                <h3 class="title"><a id="targets"/>4.4.1. Cibles du fichier <code class="filename">rules</code></h3>
              </div>
            </div>
          </div>
          <p>
Tous les fichiers <code class="filename">rules</code>, comme n'importe quel
<code class="filename">Makefile</code>, sont constitués de plusieurs règles, chacune
d'entre elles définissant une cible et comment la réaliser. <a href="#ftn.idp38997904" class="footnote" id="idp38997904"><sup class="footnote">[37]</sup></a> Une nouvelle règle commence avec la déclaration de
sa cible en première colonne. Les lignes suivantes commençant par une
tabulation (caractère ASCII 9 : TAB) indiquent ce qui doit être réalisé pour
cette cible. Les lignes vides et celles qui commencent par dièse
(<code class="literal">#</code>) sont traitées comme des commentaires et sont
ignorées. <a href="#ftn.idp39002752" class="footnote" id="idp39002752"><sup class="footnote">[38]</sup></a>
</p>
          <p>
Une règle que vous voulez exécuter est appelée par le nom de sa cible comme
un argument de la ligne de commande. Par exemple <code class="literal">debian/rules
<em class="replaceable"><code>build</code></em></code> et <code class="literal">fakeroot make -f
debian/rules <em class="replaceable"><code>binary</code></em></code> exécutent
respectivement les règles pour les cibles
<code class="literal"><em class="replaceable"><code>build</code></em></code> et
<code class="literal"><em class="replaceable"><code>binary</code></em></code>.
</p>
          <p>
Voici une explication simplifiée des cibles :
</p>
          <div class="itemizedlist">
            <ul class="itemizedlist">
              <li class="listitem">
                <p>
<code class="literal">clean</code> (obligatoire) : pour nettoyer tous les fichiers
compilés, créés, et inutiles de l'arborescence de construction ;
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">build</code> (obligatoire) : pour construire les programmes
compilés et les documents formatés à partir des sources dans l'arborescence
de construction ;
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">build-arch</code> (obligatoire) : pour construire les programmes
compilés dépendants de l'architecture à partir des sources dans
l'arborescence de construction ;
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">build-indep</code> (obligatoire) : pour construire les documents
formatés indépendants de l'architecture à partir des sources dans
l'arborescence de construction ;
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">install</code> (optionnelle) : pour installer les fichiers dans
l'arborescence de chaque paquet binaire dans le répertoire
<code class="filename">debian</code>. Si elles existent, les cibles
<code class="literal">binary*</code> dépendent en réalité de cette cible.
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">binary</code> (obligatoire) : pour créer tous les paquets
binaires (en réalité, une combinaison des cibles
<code class="literal">binary-arch</code> et <code class="literal">binary-indep</code>) ;
<a href="#ftn.idp39018928" class="footnote" id="idp39018928"><sup class="footnote">[39]</sup></a>
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">binary-arch</code> (obligatoire) : pour créer tous les paquets
binaires dépendants de l'architecture (<code class="literal">Architecture: any</code>)
dans le répertoire parent ;<a href="#ftn.idp39022384" class="footnote" id="idp39022384"><sup class="footnote">[40]</sup></a>
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">binary-indep</code> (obligatoire) : pour créer tous les paquets
binaires indépendants de l'architecture (<code class="literal">Architecture:
all</code>) dans le répertoire parent ;<a href="#ftn.idp39025952" class="footnote" id="idp39025952"><sup class="footnote">[41]</sup></a>
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">get-orig-source</code> (optionnelle) : pour obtenir la dernière
version du paquet source d'origine à partir d'une archive amont.
</p>
              </li>
            </ul>
          </div>
          <p>
Vous vous sentez sans doute submergé pour l'instant, mais les choses vont
vraiment se simplifier à l'examen du fichier <code class="filename">rules</code> que
<span class="command"><strong>dh_make</strong></span> donne par défaut.
</p>
        </div>
        <div class="section">
          <div class="titlepage">
            <div>
              <div>
                <h3 class="title"><a id="defaultrules"/>4.4.2. Fichier <code class="filename">rules</code> par défaut</h3>
              </div>
            </div>
          </div>
          <p>
Les versions récentes de <span class="command"><strong>dh_make</strong></span> créent un fichier
<code class="filename">rules</code> par défaut très simple mais aussi très puissant
en utilisant la commande <span class="command"><strong>dh</strong></span> :
</p>
          <pre class="screen">
 1 #!/usr/bin/make -f
 2 # consulter debhelper(7) (décommenter lorsque nécessaire)
 3 # afficher chaque commande modifiant un fichier dans le système construit
 4 #DH_VERBOSE = 1
 5 
 6 # consulter EXAMPLES dans dpkg-buildflags(1) et lire /usr/share/dpkg/*
 7 DPKG_EXPORT_BUILDFLAGS = 1
 8 include /usr/share/dpkg/default.mk
 9 
10 # consulter FEATURE AREAS dans dpkg-buildflags(1)
11 #export DEB_BUILD_MAINT_OPTIONS = hardening=+all
12
13 # consulter ENVIRONMENT dans dpkg-buildflags(1)
14 # mainteneurs de paquet à ajouter à CFLAGS
15 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
16 # mainteneurs de paquet à ajouter à append LDFLAGS
17 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
18 
19 # principal script d’empaquetage basé sur la syntaxe de dh7
20 %:
21         dh $@ 
</pre>
          <p>
(Les numéros de ligne ont été ajoutés et certains commentaires réduits. Dans
le vrai fichier <code class="filename">rules</code>, l’espace de début est une
tabulation.)
</p>
          <p>
Vous avez probablement l'habitude de la ligne 1 avec les scripts shell et
Perl. Cela signifie que ce fichier doit être exécuté par
<code class="filename">/usr/bin/make</code>.
</p>
          <p>
La ligne 4 peut être décommentée pour configurer la variable
<code class="literal">DH_VERBOSE</code> à 1, afin que la commande
<span class="command"><strong>dh</strong></span> affiche les commandes <span class="command"><strong>dh_*</strong></span> qu'elle
exécute. Vous pouvez également ajouter ici une ligne <code class="literal">export
DH_OPTIONS=-v</code>, afin que chaque commande <span class="command"><strong>dh_*</strong></span>
affiche les commandes qu'elle exécute. Cela permet de comprendre ce qui se
passe exactement derrière ce simple fichier <code class="filename">rules</code>, et
de déboguer ses problèmes. Ce nouveau <span class="command"><strong>dh</strong></span> est conçu pour
constituer un élément essentiel des outils <code class="systemitem">debhelper</code> sans rien vous cacher.
</p>
          <p>
Tout le travail est réalisé aux lignes 20 et 21 avec une règle implicite
utilisant la règle de motif. Le caractère pourcent (<code class="literal">%</code>)
représente « n’importe quelle cible », lequel appelle alors un seul
programme, <span class="command"><strong>dh</strong></span>, avec le nom de la cible. <a href="#ftn.idp39052912" class="footnote" id="idp39052912"><sup class="footnote">[42]</sup></a> La commande <span class="command"><strong>dh</strong></span> est un script
d'emballage qui exécute les séquences opportunes de programmes
<span class="command"><strong>dh_*</strong></span> dépendant de ses paramètres : <a href="#ftn.idp39062512" class="footnote" id="idp39062512"><sup class="footnote">[43]</sup></a>
</p>
          <div class="itemizedlist">
            <ul class="itemizedlist">
              <li class="listitem">
                <p>
<code class="literal">debian/rules clean</code> exécute <code class="literal">dh clean</code>,
qui exécute à son tour :
</p>
                <pre class="screen">
dh_testdir
dh_auto_clean
dh_clean
</pre>
              </li>
              <li class="listitem">
                <p>
<code class="literal">debian/rules build</code> exécute <code class="literal">dh build</code>,
qui exécute à son tour :
</p>
                <pre class="screen">
dh_testdir
dh_auto_configure
dh_auto_build
dh_auto_test
</pre>
              </li>
              <li class="listitem">
                <p>
<code class="literal">fakeroot debian/rules binary</code> exécute <code class="literal">fakeroot dh
binary</code>, qui exécute à son tour : <a href="#ftn.idp39072160" class="footnote" id="idp39072160"><sup class="footnote">[44]</sup></a>
</p>
                <pre class="screen">
dh_testroot
dh_prep
dh_installdirs
dh_auto_install
dh_install
dh_installdocs
dh_installchangelogs
dh_installexamples
dh_installman
dh_installcatalogs
dh_installcron
dh_installdebconf
dh_installemacsen
dh_installifupdown
dh_installinfo
dh_installinit
dh_installmenu
dh_installmime
dh_installmodules
dh_installlogcheck
dh_installlogrotate
dh_installpam
dh_installppp
dh_installudev
dh_installwm
dh_installxfonts
dh_bugfiles
dh_lintian
dh_gconf
dh_icons
dh_perl
dh_usrlocal
dh_link
dh_compress
dh_fixperms
dh_strip
dh_makeshlibs
dh_shlibdeps
dh_installdeb
dh_gencontrol
dh_md5sums
dh_builddeb
</pre>
              </li>
              <li class="listitem">
                <p>
<code class="literal">fakeroot debian/rules binary-arch</code> exécute
<code class="literal">fakeroot dh binary-arch</code>, qui exécute à son tour la même
séquence que <code class="literal">fakeroot dh binary</code> mais avec l'option
<code class="literal">-a</code> ajoutée à chaque commande ;
</p>
              </li>
              <li class="listitem">
                <p>
<code class="literal">fakeroot debian/rules binary-indep</code> exécute
<code class="literal">fakeroot dh binary-indep</code>, qui exécute à son tour à peu
près la même séquence que <code class="literal">fakeroot dh binary</code> à
l'exception de <span class="command"><strong>dh_strip</strong></span>, <span class="command"><strong>dh_makeshlibs</strong></span>
et <span class="command"><strong>dh_shlibdeps</strong></span>, et avec l'option <code class="literal">-i</code>
ajoutée à chaque commande restante.
</p>
              </li>
            </ul>
          </div>
          <p>
Le rôle des commandes <span class="command"><strong>dh_*</strong></span> est presque évident d'après
leur nom. <a href="#ftn.idp39082496" class="footnote" id="idp39082496"><sup class="footnote">[45]</sup></a> Les plus remarquables
d'entre elles valent la peine d'être (très) brièvement présentées de façon
simplifiée, dans l'hypothèse d'un environnement de construction basé sur un
<code class="filename">Makefile</code> : <a href="#ftn.idp39085360" class="footnote" id="idp39085360"><sup class="footnote">[46]</sup></a>
</p>
          <div class="itemizedlist">
            <ul class="itemizedlist">
              <li class="listitem">
                <p>
<span class="command"><strong>dh_auto_clean</strong></span> exécute normalement ce qui suit si un
<code class="filename">Makefile</code> fournit la cible
<code class="literal">distclean</code> : <a href="#ftn.idp39089472" class="footnote" id="idp39089472"><sup class="footnote">[47]</sup></a>
</p>
                <pre class="screen">
make distclean
</pre>
              </li>
              <li class="listitem">
                <p>
<span class="command"><strong>dh_auto_configure</strong></span> exécute normalement ce qui suit si
<code class="filename">./configure</code> existe (les paramètres sont abrégés pour la
lisibilité) :
</p>
                <pre class="screen">
./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var ...
</pre>
              </li>
              <li class="listitem">
                <p>
<span class="command"><strong>dh_auto_build</strong></span> exécute normalement ce qui suit pour
exécuter la première cible de <code class="filename">Makefile</code> si elle existe :
</p>
                <pre class="screen">
make
</pre>
              </li>
              <li class="listitem">
                <p>
<span class="command"><strong>dh_auto_test</strong></span> exécute normalement ce qui suit si un
<code class="filename">Makefile</code> fournit la cible <code class="literal">test</code> :
<a href="#ftn.idp39099152" class="footnote" id="idp39099152"><sup class="footnote">[48]</sup></a>
</p>
                <pre class="screen">
make test
</pre>
              </li>
              <li class="listitem">
                <p>
<span class="command"><strong>dh_auto_install</strong></span> exécute normalement ce qui suit si un
<code class="filename">Makefile</code> fournit la cible <code class="literal">install</code>
(la ligne est coupée pour la lisibilité) :
</p>
                <pre class="screen">
make install \
  DESTDIR=<em class="replaceable"><code>/chemin/vers</code></em>/<em class="replaceable"><code>paquet</code></em>_<em class="replaceable"><code>version</code></em>-<em class="replaceable"><code>révision</code></em>/debian/<em class="replaceable"><code>paquet</code></em>
</pre>
              </li>
            </ul>
          </div>
          <p>
Toutes les cibles ayant besoin de la commande <span class="command"><strong>fakeroot</strong></span>
contiendront <span class="command"><strong>dh_testroot</strong></span>, qui se terminera en erreur si
vous n'utilisez pas cette commande afin de vous faire passer pour le
superutilisateur.
</p>
          <p>
Le plus important à propos du fichier <code class="filename">rules</code> créé par
<span class="command"><strong>dh_make</strong></span>, c'est qu'il ne s'agit que d'une suggestion. Il
fonctionnera pour la plupart des paquets, mais pour les plus compliqués,
vous ne devez pas hésiter à le modifier pour le faire correspondre à vos
besoins.
</p>
          <p>
Bien que la cible <code class="literal">install</code> ne soit pas obligatoire, elle
est prise en charge. <code class="literal">fakeroot dh install</code> se comporte
comme <code class="literal">fakeroot dh binary</code> mais s'arrête après
<span class="command"><strong>dh_fixperms</strong></span>.
</p>
        </div>
        <div class="section">
          <div class="titlepage">
            <div>
              <div>
                <h3 class="title"><a id="customrules"/>4.4.3. Personnalisation du fichier <code class="filename">rules</code></h3>
              </div>
            </div>
          </div>
          <p>
Il existe plusieurs façons de personnaliser le fichier
<code class="filename">rules</code> créé avec la nouvelle commande
<span class="command"><strong>dh</strong></span>.
</p>
          <p>
La commande <code class="literal">dh $@</code> peut être personnalisée comme suit :
<a href="#ftn.idp39115824" class="footnote" id="idp39115824"><sup class="footnote">[49]</sup></a>
</p>
          <div class="itemizedlist">
            <ul class="itemizedlist">
              <li class="listitem">
                <p>
ajout de l'assistance pour la commande <span class="command"><strong>dh_python2</strong></span> (la
meilleure solution pour Python) : <a href="#ftn.idp39119696" class="footnote" id="idp39119696"><sup class="footnote">[50]</sup></a>
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">python</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with python2</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : gestion des modules Python avec la structure <code class="systemitem">python</code> ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour la commande <span class="command"><strong>dh_pysupport</strong></span>
(obsolète) :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">python-support</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with pysupport</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : gestion des modules Python avec la structure <code class="systemitem">python-support</code> ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour la commande <span class="command"><strong>dh_pycentral</strong></span>
(obsolète) :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">python-central</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with python-central</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : désactivation de la commande <span class="command"><strong>dh_pysupport</strong></span> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : gestion des modules Python avec la structure <code class="systemitem">python-central</code> ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour la commande <span class="command"><strong>dh_installtex</strong></span> :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">tex-common</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with tex</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : enregistrement des fontes de Type 1, des modèles de césure et
des formats avec TeX ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour les commandes <span class="command"><strong>dh_quilt_patch</strong></span>
et <span class="command"><strong>dh_quilt_unpatch</strong></span> :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">quilt</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with quilt</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : application et retrait des correctifs au code source amont à
partir des fichiers du répertoire <code class="filename">debian/patches</code> pour
les paquets source au format <code class="literal">1.0</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
inutile pour les paquets source au format <code class="literal">3.0 (quilt)</code> ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour la commande <span class="command"><strong>dh_dkms</strong></span> :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">dkms</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with dkms</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : gestion correcte de l'utilisation de DKMS par les paquets de
modules du noyau ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour les commandes
<span class="command"><strong>dh_autotools-dev_updateconfig</strong></span> et
<span class="command"><strong>dh_autotools-dev_restoreconfig</strong></span> :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">autotools-dev</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with autotools-dev</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : mise à jour et restauration de <code class="filename">config.sub</code>
et <code class="filename">config.guess</code> ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour les commandes <span class="command"><strong>dh_autoreconf</strong></span> et
<span class="command"><strong>dh_autoreconf_clean</strong></span> :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">dh-autoreconf</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with autoreconf</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : mise à jour des fichiers du système de construction GNU et
restauration de ceux-ci après la construction ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour la commande <span class="command"><strong>dh_girepository</strong></span> :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">gobject-introspection</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with gir</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : calcul des dépendances pour les paquets embarquant des données
d'introspection GObject et génération de la variable de substitution
<code class="literal">${gir:Depends}</code> pour les dépendances du paquet ;
</p>
                    </li>
                  </ul>
                </div>
              </li>
              <li class="listitem">
                <p>
ajout de l'assistance pour la fonctionnalité de complétion de
<span class="command"><strong>bash</strong></span> :
</p>
                <div class="itemizedlist">
                  <ul class="itemizedlist">
                    <li class="listitem">
                      <p>
ajout de <code class="systemitem">bash-completion</code> à
<code class="literal">Build-Depends</code> ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
utilisation de <code class="literal">dh $@ --with bash-completion</code> à la place ;
</p>
                    </li>
                    <li class="listitem">
                      <p>
conséquence : installation des complétions de <span class="command"><strong>bash</strong></span> en
utilisant un fichier de configuration
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em>.bash-completion</code>.
</p>
                    </li>
                  </ul>
                </div>
              </li>
            </ul>
          </div>
          <p>
De nombreuses commandes <span class="command"><strong>dh_*</strong></span> invoquées par la nouvelle
commande <span class="command"><strong>dh</strong></span> peuvent être personnalisées par les fichiers
de configuration correspondants dans le répertoire
<code class="filename">debian</code>. Consultez <a class="xref" href="dother.fr.html" title="Chapitre 5. Autres fichiers dans le répertoire debian">Chapitre 5, <em>Autres fichiers dans le répertoire <code class="filename">debian</code></em></a> et la page
de manuel de chaque commande pour la personnalisation de telles
fonctionnalités.
</p>
          <p>
Certaines commandes <span class="command"><strong>dh_*</strong></span>, invoquées à l'aide de la
nouvelle commande <span class="command"><strong>dh</strong></span>, doivent parfois être exécutées avec
des arguments supplémentaires, exécuter d'autres commandes avec elles ou
être ignorées. Pour cela, créez une cible
<code class="literal">override_dh_<em class="replaceable"><code>toto</code></em></code> avec sa règle
dans le fichier <code class="filename">rules</code> définissant une cible
<code class="literal">override_dh_<em class="replaceable"><code>toto</code></em></code> pour
remplacer la commande
<span class="command"><strong>dh_<em class="replaceable"><code>toto</code></em></strong></span>. Son rôle est
fondamentalement de dire <span class="emphasis"><em>exécute-moi à la
place</em></span>. <a href="#ftn.idp39197280" class="footnote" id="idp39197280"><sup class="footnote">[51]</sup></a>
</p>
          <p>
Les commandes <span class="command"><strong>dh_auto_*</strong></span> ont tendance à en faire plus que
ce qui a été présenté ici (très) simplement, pour prendre en compte toutes
les situations délicates. Évitez d'utiliser les cibles
<code class="literal">override_dh_*</code> pour remplacer <code class="literal">dh_*</code> par
des commandes équivalentes simplifiées (à part pour la cible
<code class="literal">override_dh_auto_clean</code>) car elles pourraient contourner
des fonctionnalités intelligentes de <code class="systemitem">debhelper</code>.
</p>
          <p>
Ainsi, par exemple pour conserver les données de configuration dans le
répertoire <code class="filename">/etc/gentoo</code> au lieu du répertoire consacré
<code class="filename">/etc</code> du dernier paquet <code class="systemitem">gentoo</code> utilisant Autotools, il suffit de
remplacer l'option <code class="literal">--sysconfig=/etc</code> donnée par la
commande <span class="command"><strong>dh_auto_configure</strong></span> à la commande
<span class="command"><strong>./configure</strong></span> avec :
</p>
          <pre class="screen">
override_dh_auto_configure:
        dh_auto_configure -- --sysconfig=/etc/gentoo
</pre>
          <p>
Les options données après <code class="literal">--</code> sont ajoutées aux options
par défaut du programme exécuté automatiquement dans le but de les
remplacer. L'utilisation de la commande <span class="command"><strong>dh_auto_configure</strong></span>
est ici préférable à l'appel de la commande <span class="command"><strong>./configure</strong></span>
puisqu'elle remplacera seulement l'option <code class="literal">--sysconfig</code> et
conservera toutes les autres options à propos de la commande
<span class="command"><strong>./configure</strong></span>.
</p>
          <p>
Si le <code class="filename">Makefile</code> des sources de <code class="systemitem">gentoo</code> nécessite de préciser
<code class="literal">build</code> comme cible pour la construction <a href="#ftn.idp39212224" class="footnote" id="idp39212224"><sup class="footnote">[52]</sup></a>, vous pouvez créer une cible
<code class="literal">override_dh_auto_build</code> pour cela.
</p>
          <pre class="screen">
override_dh_auto_build:
        dh_auto_build -- build
</pre>
          <p>
Cela garantit l'exécution de <code class="literal">$(MAKE)</code> avec toutes les
options par défaut données à la commande <span class="command"><strong>dh_auto_build</strong></span>
avec en plus le paramètre <code class="literal">build</code>.
</p>
          <p>
Si le <code class="filename">Makefile</code> des sources de <code class="systemitem">gentoo</code> oblige à préciser la cible
<code class="literal">packageclean</code> pour nettoyer le paquet Debian au lieu
d'utiliser les cibles <code class="literal">distclean</code> ou
<code class="literal">clean</code>, vous pouvez créer une cible
<code class="literal">override_dh_auto_clean</code> pour l'activer.
</p>
          <pre class="screen">
override_dh_auto_clean:
        $(MAKE) packageclean
</pre>
          <p>
Si le <code class="filename">Makefile</code> des sources pour <code class="systemitem">gentoo</code> contient une cible
<code class="literal">test</code> dont vous ne voulez pas pour exécuter le processus
de construction du paquet Debian, vous pouvez utiliser une cible
<code class="literal">override_dh_auto_test</code> vide pour l'omettre.
</p>
          <pre class="screen">
override_dh_auto_test:
</pre>
          <p>
Si <code class="systemitem">gentoo</code> possède un fichier journal
de modification inhabituel appelé <code class="filename">FIXES</code>,
<span class="command"><strong>dh_installchangelogs</strong></span> ne l'installera pas par défaut. La
commande <span class="command"><strong>dh_installchangelogs</strong></span> a besoin de
<code class="filename">FIXES</code> en option pour l'installer. <a href="#ftn.idp39226960" class="footnote" id="idp39226960"><sup class="footnote">[53]</sup></a>
</p>
          <pre class="screen">
override_dh_installchangelogs:
        dh_installchangelogs FIXES
</pre>
          <p>
Lors de l'utilisation de la nouvelle commande <span class="command"><strong>dh</strong></span>, la
compréhension des effets exacts des cibles explicites comme celles énumérées
en <a class="xref" href="dreq.fr.html#targets" title="4.4.1. Cibles du fichier rules">Section 4.4.1, « Cibles du fichier <code class="filename">rules</code> »</a> (à part <code class="literal">get-orig-source</code>)
peut être rendue difficile. Veuillez limiter les cibles explicites aux
cibles <code class="literal">override_dh_*</code>, et à celles complètement
indépendantes, si possible.
</p>
        </div>
      </div>
      <div class="footnotes">
        <br/>
        <hr/>
        <div id="ftn.idp38807984" class="footnote">
          <p><a href="#idp38807984" class="para"><sup class="para">[27] </sup></a>
Dans ce chapitre, <code class="filename">debian/</code> est omis pour simplifier
l'écriture des fichiers du répertoire <code class="filename">debian</code> quand la
signification n'est pas ambiguë.
</p>
        </div>
        <div id="ftn.idp38824480" class="footnote">
          <p><a href="#idp38824480" class="para"><sup class="para">[28] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-archive.html#s-subsections">Charte Debian,
2.4 « Sections »</a> et la <a class="ulink" href="http://packages.debian.org/unstable/">liste des
sections dans <code class="literal">sid</code></a>.</p>
        </div>
        <div id="ftn.idp38828640" class="footnote">
          <p><a href="#idp38828640" class="para"><sup class="para">[29] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-archive.html#s-priorities">Charte Debian,
2.5 « Priorités »</a>.
</p>
        </div>
        <div id="ftn.idp38841424" class="footnote">
          <p><a href="#idp38841424" class="para"><sup class="para">[30] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-relationships.html#s-sourcebinarydeps">Charte
Debian, 7.7 « Relations entre paquets source et binaires — Build-Depends,
Build-Depends-Indep, Build-Conflicts, Build-Conflicts-Indep »</a></p>
        </div>
        <div id="ftn.idp38857152" class="footnote">
          <p><a href="#idp38857152" class="para"><sup class="para">[31] </sup></a> Cette situation quelque peu étrange est une fonctionnalité bien expliquée
dans la <a class="ulink" href="http://www.debian.org/doc/debian-policy/footnotes.html#f55">Charte Debian, note de bas
de page 55</a>. Ce n'est pas lié à l'utilisation de la commande
<span class="command"><strong>dh</strong></span> dans le fichier <code class="filename">debian/rules</code> mais
au fonctionnement de <span class="command"><strong>dpkg-buildpackage</strong></span>. La même situation
s'applique au <a class="ulink" href="https://bugs.launchpad.net/launchpad-buildd/+bug/238141">système de
construction automatique pour Ubuntu</a>.  </p>
        </div>
        <div id="ftn.idp38875136" class="footnote">
          <p><a href="#idp38875136" class="para"><sup class="para">[32] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-controlfields.html#s-f-Architecture">Charte Debian,
5.6.8 « Architecture »</a> pour de plus amples précisions.
</p>
        </div>
        <div id="ftn.idp38895088" class="footnote">
          <p><a href="#idp38895088" class="para"><sup class="para">[33] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-archive.html#s-priorities">Charte Debian, 7 « Déclaration
de relations entre paquets »</a>.
</p>
        </div>
        <div id="ftn.idp38946320" class="footnote">
          <p><a href="#idp38946320" class="para"><sup class="para">[34] </sup></a>Ces descriptions sont en anglais. Les traductions de ces descriptions sont
fournies par <a class="ulink" href="http://www.debian.org/intl/l10n/ddtp">Le projet de traduction de descriptions de
Debian — DDTP</a>.</p>
        </div>
        <div id="ftn.idp38948800" class="footnote">
          <p><a href="#idp38948800" class="para"><sup class="para">[35] </sup></a>Consultez la <a class="ulink" href="http://www.debian.org/doc/manuals/developers-reference/best-pkging-practices.html#bpp-vcs">référence du Développeur Debian,
6.2.5. « Emplacement du système de gestion de versions »</a>.
</p>
        </div>
        <div id="ftn.idp38988224" class="footnote">
          <p><a href="#idp38988224" class="para"><sup class="para">[36] </sup></a>Si vous utilisez la commande <code class="literal">dch -r</code> pour faire cette
dernière modification, n'oublier pas de sauver le fichier
<code class="filename">changelog</code> explicitement dans l'éditeur.</p>
        </div>
        <div id="ftn.idp38997904" class="footnote">
          <p><a href="#idp38997904" class="para"><sup class="para">[37] </sup></a>Vous pouvez apprendre les bases pour écrire un <code class="filename">Makefile</code>
dans la <a class="ulink" href="http://www.debian.org/doc/manuals/debian-reference/ch12#_make">référence Debian,
12.2. « Make »</a>. La documentation complète est disponible en <a class="ulink" href="http://www.gnu.org/software/make/manual/html_node/index.html">http://www.gnu.org/software/make/manual/html_node/index.html</a> et dans le paquet <code class="systemitem">make-doc</code> de la partie
<code class="literal">non-free</code> de l'archive.
</p>
        </div>
        <div id="ftn.idp39002752" class="footnote">
          <p><a href="#idp39002752" class="para"><sup class="para">[38] </sup></a>La <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules">Charte Debian, 4.9 « Script de
construction principal : debian/rules »</a> explique les détails.</p>
        </div>
        <div id="ftn.idp39018928" class="footnote">
          <p><a href="#idp39018928" class="para"><sup class="para">[39] </sup></a> Cette cible est utilisée par <code class="literal">dpkg-buildpackage</code> comme en
<a class="xref" href="build.fr.html#completebuild" title="6.1. Reconstruction complète">Section 6.1, « Reconstruction complète »</a>.  </p>
        </div>
        <div id="ftn.idp39022384" class="footnote">
          <p><a href="#idp39022384" class="para"><sup class="para">[40] </sup></a> Cette cible est utilisée par <code class="literal">dpkg-buildpackage -B</code> comme
en <a class="xref" href="build.fr.html#autobuilder" title="6.2. Serveurs d'empaquetage automatique (« autobuilder »)">Section 6.2, « Serveurs d'empaquetage automatique (« autobuilder ») »</a>.  </p>
        </div>
        <div id="ftn.idp39025952" class="footnote">
          <p><a href="#idp39025952" class="para"><sup class="para">[41] </sup></a> Cette cible est utilisée par <code class="literal">dpkg-buildpackage -A</code>.  </p>
        </div>
        <div id="ftn.idp39052912" class="footnote">
          <p><a href="#idp39052912" class="para"><sup class="para">[42] </sup></a> Ceci utilise les fonctionnalités du nouveau <code class="systemitem">debhelper</code> v7+. Ses concepts fondateurs sont
expliqués dans la présentation <a class="ulink" href="http://joey.kitenet.net/talks/debhelper/debhelper-slides.pdf">Pas le
debhelper de papy</a> réalisé lors de la dixième conférence Debian par
l'auteur de <code class="systemitem">debhelper</code>. Sous
<code class="literal">Lenny</code>, <span class="command"><strong>dh_make</strong></span> créait un fichier
<code class="filename">rules</code> beaucoup plus compliqué avec des règles
explicites et de nombreux scripts <span class="command"><strong>dh_*</strong></span> énumérés pour
chacune, la plupart n'étant plus nécessaires maintenant (et montre l'âge du
paquet). La nouvelle commande <span class="command"><strong>dh</strong></span> plus simple libère le
responsable de ce travail de routine « manuel ». Vous gardez les pleins
pouvoirs de personnalisation du processus avec les cibles
<code class="literal">override_dh_*</code>. Consultez <a class="xref" href="dreq.fr.html#customrules" title="4.4.3. Personnalisation du fichier rules">Section 4.4.3, « Personnalisation du fichier <code class="filename">rules</code> »</a>. Il se base uniquement sur le paquet <code class="systemitem">debhelper</code> et ne rend pas obscur le processus de
construction comme le paquet <code class="systemitem">cdbs</code> a
tendance à le faire.  </p>
        </div>
        <div id="ftn.idp39062512" class="footnote">
          <p><a href="#idp39062512" class="para"><sup class="para">[43] </sup></a> Vous pouvez vérifier les réelles séquences des programmes
<span class="command"><strong>dh_*</strong></span> pour une
<code class="literal"><em class="replaceable"><code>cible</code></em></code> donnée sans vraiment les
exécuter en appelant <code class="literal">dh --no-act
<em class="replaceable"><code>cible</code></em></code> ou <code class="literal">debian/rules --
'--no-act <em class="replaceable"><code>cible</code></em>'</code>.  </p>
        </div>
        <div id="ftn.idp39072160" class="footnote">
          <p><a href="#idp39072160" class="para"><sup class="para">[44] </sup></a>L'exemple suivant suppose que <code class="filename">debian/compat</code> a une
valeur au moins égale à 9 pour éviter d'invoquer une commande d'assistance
Python automatiquement.
</p>
        </div>
        <div id="ftn.idp39082496" class="footnote">
          <p><a href="#idp39082496" class="para"><sup class="para">[45] </sup></a> Pour obtenir des renseignements complets sur le rôle exact de tous ces
scripts <span class="command"><strong>dh_*</strong></span> et sur leurs options, veuillez lire leur
page de manuel respective et la documentation de <code class="systemitem">debhelper</code>.  </p>
        </div>
        <div id="ftn.idp39085360" class="footnote">
          <p><a href="#idp39085360" class="para"><sup class="para">[46] </sup></a> Ces commandes gèrent d'autres environnements, comme
<code class="filename">setup.py</code>, qui peuvent être énumérés en exécutant
<code class="literal">dh_auto_build --list</code> dans le répertoire d'un paquet
source.  </p>
        </div>
        <div id="ftn.idp39089472" class="footnote">
          <p><a href="#idp39089472" class="para"><sup class="para">[47] </sup></a> En fait, il recherche la première cible disponible dans le
<code class="filename">Makefile</code> parmi <code class="literal">distclean</code>,
<code class="literal">realclean</code> et <code class="literal">clean</code>, et l'exécute.
</p>
        </div>
        <div id="ftn.idp39099152" class="footnote">
          <p><a href="#idp39099152" class="para"><sup class="para">[48] </sup></a> En fait, il recherche dans le <code class="filename">Makefile</code> la première
cible disponible parmi <code class="literal">test</code> et <code class="literal">check</code>,
et l'exécute.</p>
        </div>
        <div id="ftn.idp39115824" class="footnote">
          <p><a href="#idp39115824" class="para"><sup class="para">[49] </sup></a> Si un paquet installe le fichier
<code class="filename">/usr/share/perl5/Debian/Debhelper/Sequence/<em class="replaceable"><code>nom_personnalise</code></em>.pm</code>,
vous devriez déclencher sa fonction de personnalisation avec <code class="literal">dh $@
--with <em class="replaceable"><code>nom-personnalise</code></em></code>.  </p>
        </div>
        <div id="ftn.idp39119696" class="footnote">
          <p><a href="#idp39119696" class="para"><sup class="para">[50] </sup></a> L'utilisation de la commande <span class="command"><strong>dh_python2</strong></span> est préférable à
<span class="command"><strong>dh_pysupport</strong></span> ou
<span class="command"><strong>dh_pycentral</strong></span>. N'utilisez pas la commande
<span class="command"><strong>dh_python</strong></span>.  </p>
        </div>
        <div id="ftn.idp39197280" class="footnote">
          <p><a href="#idp39197280" class="para"><sup class="para">[51] </sup></a> Avec <code class="literal">Lenny</code>, pour modifier le comportement d'un script
<span class="command"><strong>dh_*</strong></span> il fallait trouver et adapter la ligne pertinente du
fichier <code class="filename">rules</code>.  </p>
        </div>
        <div id="ftn.idp39212224" class="footnote">
          <p><a href="#idp39212224" class="para"><sup class="para">[52] </sup></a>
<span class="command"><strong>dh_auto_build</strong></span> sans autre option exécutera la première
cible du <code class="filename">Makefile</code>.  </p>
        </div>
        <div id="ftn.idp39226960" class="footnote">
          <p><a href="#idp39226960" class="para"><sup class="para">[53] </sup></a> Les fichiers <code class="filename">debian/changelog</code> et
<code class="filename">debian/NEWS</code> sont toujours installés automatiquement. Le
journal de modification amont est trouvé en convertissant les noms de
fichiers en minuscule puis en vérifiant l'existence de
<code class="filename">changelog</code>, <code class="filename">changes</code>,
<code class="filename">changelog.txt</code> et <code class="filename">changes.txt</code>.
</p>
        </div>
      </div>
    </div>
    <div class="navfooter">
      <hr/>
      <table width="100%" summary="Navigation footer">
        <tr>
          <td align="left"><a accesskey="p" href="modify.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <td align="center"> </td>
          <td align="right"> <a accesskey="n" href="dother.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
        <tr>
          <td align="left" valign="top">Chapitre 3. Modification du code source </td>
          <td align="center">
            <a accesskey="h" href="index.fr.html">
              <img src="images/home.png" alt="Sommaire"/>
            </a>
          </td>
          <td align="right" valign="top"> Chapitre 5. Autres fichiers dans le répertoire <code class="filename">debian</code></td>
        </tr>
      </table>
    </div>
  </body>
</html>
